### Method

# Camel Session list_services

since: 3.2

#### Declaration [src]

    GList*
    camel_session_list_services (
      CamelSession* session
    )

#### Description [src]

Returns a list of all `CamelService` objects previously added using camel_session_add_service().

The services returned in the list are referenced for thread-safety. They must each be unreferenced with `g_object_unref()` when finished with them. Free the returned list itself with g_list_free().

An easy way to free the list property in one step is as follows:

      g_list_free_full (list, g_object_unref);

Available since: 3.2

#### Return value

Type: A list of `None`

An unsorted list of `CamelService` objects.

The caller of the method takes ownership of the returned data, and is responsible for freeing it.